/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ppp_fsm.h,v 1.3 2006/02/07 10:10:10 abe Exp abe $
 */

/*
 * fsm.h - {Link, IP} Control Protocol Finite State Machine definitions.
 *
 * Copyright (c) 1989 Carnegie Mellon University.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Carnegie Mellon University.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $FreeBSD: src/usr.sbin/pppd/fsm.h,v 1.6.2.1 1999/08/29 15:47:00 peter Exp $
 */

/*
 *	    Written by Toshiharu OHNO (tony-o@iij.ad.jp)
 *
 *   Copyright (C) 1993, Internet Initiative Japan, Inc. All rights reserverd.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by the Internet Initiative Japan.  The name of the
 * IIJ may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $FreeBSD: src/usr.sbin/ppp/fsm.h,v 1.23 1999/12/27 11:54:53 brian Exp $
 *
 *	TODO:
 */

#ifndef _PPP_FSM_H_
#define _PPP_FSM_H_

#ifdef SUPPORT_PPP

/*
 *  ִ¤
 */

struct t_ppp_fsm_callbacks;

typedef struct t_fsm {
	struct t_ppp_fsm_callbacks	*callbacks;	/* Хåؿ*/
	UH	proto;		/* ץȥ				*/
	UB	state;		/* FSM ξ				*/
	UB	id;		/* ߤ ID				*/
	UB	reqid;		/* ׵ ID				*/
	UB	seen_ack;	/* ׵Ф ACK/NAK/REJ 	*/
	B	failures;	/* ǧ NAK 			*/
	B	retrans;	/* Configure-Request ޤϡ		*/
				/* Terminate-Request κ		*/
	} T_PPP_FSM;

#define T_PPP_FSM_DEFINED

/*
 *  Хåؿ¤
 */

typedef struct t_ppp_fsm_callbacks {
	void (*resetci)	(T_PPP_FSM *);	/* ꥻåȤ롣	*/
	INT  (*cilen)	(T_PPP_FSM *);	/* Ĺ֤		*/
	void (*addci)	(T_PPP_FSM *, T_NET_BUF *);
					/* ɲä롣		*/
	BOOL (*ackci)	(T_PPP_FSM *, T_NET_BUF *);
					/* ACK Ȥν	*/
	INT  (*nakci)	(T_PPP_FSM *, T_NET_BUF *);
					/* NAK Ȥν	*/
	INT  (*rejci)	(T_PPP_FSM *, T_NET_BUF *);
					/* REJ Ȥν	*/
	INT  (*reqci)	(T_PPP_FSM *, T_NET_BUF *, T_NET_BUF *);
					/* ιǧ롣	*/
	void (*up)	(T_PPP_FSM *);	/* 󥯤³Ω롣	*/
	void (*down)	(T_PPP_FSM *);	/* 󥯤³롣	*/
	void (*starting)(T_PPP_FSM *);	/* ؤ򳫻Ϥ롣		*/
	void (*finished)(T_PPP_FSM *);	/* ؤλ롣		*/
	void (*retrans)	(T_PPP_FSM *);	/* 롣			*/
					/*  CP Ȥν	*/
	BOOL  (*extcode)(T_PPP_FSM *, UB, UB, T_NET_BUF *);
	} T_PPP_FSM_CALLBACKS;

/*
 *  FSM ξ
 */

#define PPP_FSM_INITIAL		0	/* ̤³̤ץ	*/
#define PPP_FSM_STARTING	1	/* ̤³ץ	*/
#define PPP_FSM_CLOSED		2	/* ³  ̤ץ	*/
#define PPP_FSM_STOPPED		3	/* ץԤ	*/
#define PPP_FSM_CLOSING		4	/* 桢̤ץ	*/
#define PPP_FSM_STOPPING	5	/* 桢ץ	*/
#define PPP_FSM_REQSENT		6	/* Config REQ Ѥ	*/
#define PPP_FSM_ACKRCVD		7	/* Config ACK Ѥ	*/
#define PPP_FSM_ACKSENT		8	/* Config ACK Ѥ	*/
#define PPP_FSM_OPENED		9	/* ³̿ǽ	*/

/*
 *  ץư⡼
 */

#define PPP_OPEN_PASSIVE	FALSE	/* ưץ		*/
#define PPP_OPEN_ACTIVE		TRUE	/* ǽưץ		*/

/*
 *  ॢȤδ
 */

#define DEF_PPP_TIMEOUT		(3*NET_TIMER_HZ)
					/* RFC1661 Ǥ  3 			*/
#define MAX_PPP_TERMINATES	2	/* Terminate-Requests κ	*/
					/* RFC1661 Ǥ  2 			*/
#define MAX_PPP_CONFIGURES	10	/* Configure-Requests κ	*/
					/* RFC1661 Ǥ 10 			*/
#define MAX_PPP_FAILURES	5	/* Configure-NAK κǧ		*/
					/* RFC1661 Ǥ  5 			*/

/*
 *  ؿ
 */

extern void fsm_init    (T_PPP_FSM *fsm);
extern void fsm_lowerup (T_PPP_FSM *fsm);
extern void fsm_lowerdown(T_PPP_FSM *fsm);
extern void fsm_open    (T_PPP_FSM *fsm);
extern void fsm_close	(T_PPP_FSM *fsm);
extern void fsm_input	(T_PPP_FSM *fsm, T_NET_BUF *data);
extern void fsm_protreject(T_PPP_FSM *fsm);

/*
 *  ѿ
 */

extern UB ppp_open_mode;

#endif	/* of #ifdef SUPPORT_PPP */

#endif	/* of #ifndef _PPP_FSM_H_ */
