/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp_echo_srv.c,v 1.3 2006/02/07 10:12:14 abe Exp abe $
 */

/* 
 *  UDP ECHO 
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/echo.h>

#ifdef USE_UDP_ECHO_SRV

/*
 *  ॢ
 */

#define RCV_TMOUT	TMO_FEVR
//#define RCV_TMOUT	(30*1000)

/*
 *  ѿ
 */

#define BUF_SIZE	2048

static UB	echo_rcv_buf[BUF_SIZE];
static T_IPEP	dst;

#ifdef USE_UDP_NON_BLOCKING

#ifndef USE_UDP_CALL_BACK

static ER_UINT		len;

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_udp_echo_srv (ID cepid, FN fncd, VP p_parblk)
{
	SYSTIM	now;

	get_tim(&now);
	len = (ER_UINT)p_parblk;
	if (len < 0) {	/* 0 ʲξϡ顼 */
		syslog(LOG_NOTICE, "[UES:%02d CBR] error,      %6d: %s, fncd: %s",
		                   cepid, now / SYSTIM_HZ, itron_strerror(len), in_strtfn(fncd));
		len = 0;
		}
	else if (fncd == TFN_UDP_RCV_DAT) {
		echo_rcv_buf[len] = '\0';
		syslog(LOG_NOTICE, "[UES:%02d CBR] received,   %6d, from: %s.%d, msg: %s",
		                   cepid, now / SYSTIM_HZ, IP2STR(NULL, &dst.ipaddr), dst.portno, echo_rcv_buf);
		}
	syscall(wup_tsk(UDP_ECHO_SRV_TASK));
	return E_OK;
	}

/*
 *  UDP ECHO Х
 */

void
udp_echo_srv_task(VP_INT exinf)
{
	ID	tskid;
	ER	error;
	UINT	rlen;
	SYSTIM	now;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[UDP ECHO SRV (NBLK):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((error = UDP_RCV_DAT((ID)exinf, &dst, (VP)echo_rcv_buf, sizeof(echo_rcv_buf), TMO_NBLK)) != E_WBLK) {
			get_tim(&now);
			syslog(LOG_NOTICE, "[UES:%02d RCV] recv error, %6d: %s",
			                   (ID)exinf, now / SYSTIM_HZ, itron_strerror(error));
			continue;
			}

		syscall(slp_tsk());
		rlen = len;
		if (rlen > 0) {
			if ((error = UDP_SND_DAT((ID)exinf, &dst, (VP)echo_rcv_buf, rlen, TMO_NBLK)) != E_WBLK) {
				get_tim(&now);
				syslog(LOG_NOTICE, "[UES:%02d RCV] send error, %6d: %s",
				                   (ID)exinf, now / SYSTIM_HZ, itron_strerror(error));
				continue;
				}

			syscall(slp_tsk());
			if (rlen >= 0) {
				get_tim(&now);
				syslog(LOG_NOTICE, "[UES:%02d SND] sent,       %6d, len: %d",
				                   (ID)exinf, now / SYSTIM_HZ, rlen);
				}
			}
		}
	}

#endif	/* of #ifndef USE_UDP_CALL_BACK */

#else	/* of #ifdef USE_UDP_NON_BLOCKING */

#ifdef USE_UDP_CALL_BACK

/*
 *  Хåؿ
 */

ER
callback_udp_echo_srv (ID cepid, FN fncd, VP p_parblk)
{
	ER_UINT	len;
	SYSTIM	now;

	if ((len = UDP_RCV_DAT(cepid, &dst, (VP)echo_rcv_buf, sizeof(echo_rcv_buf), TMO_FEVR)) >= 0) {
		echo_rcv_buf[len] = '\0';
		get_tim(&now);
		syslog(LOG_NOTICE, "[UES:%02d UCB] received,   %6d, from: %s.%d, msg: %s",
		                   cepid, now / SYSTIM_HZ, IP2STR(NULL, &dst.ipaddr), dst.portno, echo_rcv_buf);
		if (len > 0) {
			len = UDP_SND_DAT(cepid, &dst, (VP)echo_rcv_buf, len, TMO_FEVR);
			get_tim(&now);
			if (len >= 0)
				syslog(LOG_NOTICE, "[UES:%02d UCB] sent,       %6d, len: %d",
				                   cepid, now / SYSTIM_HZ, len);
			else
				syslog(LOG_NOTICE, "[UES:%02d UCB] send error, %6d: %s",
				                   cepid, now / SYSTIM_HZ, itron_strerror(len));
			}
		len = E_OK;
		}
	else {
		get_tim(&now);
		syslog(LOG_NOTICE, "[UES:%02d UCB] recv error, %6d: %s",
		                   cepid, now / SYSTIM_HZ, itron_strerror(len));
		}

	return len;
	}

#else	/* of #ifdef USE_UDP_CALL_BACK */

/*
 *  UDP ECHO Х
 */

void
udp_echo_srv_task(VP_INT exinf)
{
	ER_UINT	len;
	ID	tskid;
	SYSTIM	now;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[UDP ECHO SRV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((len = UDP_RCV_DAT((ID)exinf, &dst, (VP)echo_rcv_buf, sizeof(echo_rcv_buf), RCV_TMOUT)) >= 0) {
			get_tim(&now);
			echo_rcv_buf[len] = '\0';
			syslog(LOG_NOTICE, "[UES:%02d RCV] received,   %6d, from: %s.%d, msg: %s",
			                   (ID)exinf, now / SYSTIM_HZ, IP2STR(NULL, &dst.ipaddr), dst.portno, echo_rcv_buf);
			if (len > 0) {
				len = UDP_SND_DAT((ID)exinf, &dst, (VP)echo_rcv_buf, len, TMO_FEVR);
				get_tim(&now);
				if (len >= 0)
					syslog(LOG_NOTICE, "[UES:%02d SND] sent,       %6d, len: %d",
					                   (ID)exinf, now / SYSTIM_HZ, len);
				else
					syslog(LOG_NOTICE, "[UES:%02d SND] send error, %6d: %s",
					                   (ID)exinf, now / SYSTIM_HZ, itron_strerror(len));
				}
			}
		else {
			get_tim(&now);
			syslog(LOG_NOTICE, "[UES:%02d RCV] recv error, %6d: %s",
			                    (ID)exinf, now / SYSTIM_HZ, itron_strerror(len));
			}
		}
	}

#endif	/* of #ifdef USE_UDP_CALL_BACK */

#endif	/* of #ifdef USE_UDP_NON_BLOCKING */

#endif	/* of #ifdef USE_UDP_ECHO_SRV */
