/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: in_var.h,v 1.3 2006/02/07 10:10:51 abe Exp abe $
 */

/*
 * Copyright (c) 1985, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)in_var.h	8.2 (Berkeley) 1/9/95
 * $FreeBSD: src/sys/netinet/in_var.h,v 1.29.2.1 1999/08/29 16:29:38 peter Exp $
 */
 
#ifndef _IN_VAR_H_
#define _IN_VAR_H_

#ifdef SUPPORT_INET6

#include <netinet6/in6_var.h>

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  ȼΥ顼
 */

#define EV_NOPND		(-97)		/* ڥǥ󥰤Ƥʤ */

/*
 *  ͥåȥ顼
 */

#define EV_MSIZE		(-98)		/* ǡĹĶ	*/
#define EV_NURCH		(-99)		/* ͥåȥãǽ	*/
#define EV_HDOWN		(-100)		/* ۥȥ		*/
#define EV_HURCH		(-101)		/* ۥãǽ	*/
#define EV_CNNRF		(-102)		/* ³ǽ		*/
#define EV_CNRST		(-103)		/* ³ꥻå		*/
#define EV_REXMTMO		(-104)		/* ॢ	*/

/*
 *  ̥ޤεư
 */

#define IN_TIMER_TMO		(SYSTIM_HZ/NET_TIMER_CYCLE)

/*
 *  󥿥եɥ쥹¤
 */

typedef struct t_in4_ifaddr {
	T_IN4_ADDR		addr;		/* IPv4 ɥ쥹	*/
	T_IN4_ADDR		mask;		/* ֥ͥåȥޥ	*/
	} T_IN4_IFADDR;

/*
 *  롼ƥɽȥ깽¤
 */

typedef struct t_in4_rtentry {
	T_IN4_ADDR	target;		/* ɸͥåȥɥ쥹			*/
	T_IN4_ADDR	mask;		/* ɸͥåȥɥ쥹Υ֥ͥåȥޥ	*/
	T_IN4_ADDR	gateway;	/* ȥ IP ɥ쥹			*/
	UW		expire;		/* ֤ͭڤ [s]			*/
	UB		flags;		/* ե饰					*/
	} T_IN4_RTENTRY;

/*
 *  TINET 1.1 ȤθߴΤ
 */

#ifdef NUM_ROUTE_ENTRY

#define NUM_STATIC_ROUTE_ENTRY		NUM_ROUTE_ENTRY
#define NUM_REDIRECT_ROUTE_ENTRY	0
#define T_RT_ENTRY			T_IN_RTENTRY

#else	/* of #ifdef NUM_ROUTE_ENTRY */

#define NUM_ROUTE_ENTRY			\
	(NUM_STATIC_ROUTE_ENTRY + NUM_REDIRECT_ROUTE_ENTRY)
					/* 롼ƥɽΥȥ	*/

#endif	/* of #ifdef NUM_ROUTE_ENTRY */

/*
 *  롼ƥ󥰥ȥ֥ե饰
 */

#define IN_RTF_DEFINED		0x01	/* Ѥ			*/
#define IN_RTF_REDIRECT		0x10	/* ľˤ꼫ưꤵ줿	*/

/*
 *  IPv4  IPv6 򥳥ѥ򤹤뤿Υޥ
 */

#ifdef SUPPORT_INET4

#define IN_SET_HEADER(nbuf,len,dst,src,proto,ttl)	\
					in4_set_header(nbuf,len,dst,src,proto,ttl)
#define IN_GET_DATAGRAM(nbuf,len,maxlen, dst,src,proto,ttl,nbatr,tmout)	\
					in4_get_datagram(nbuf,len,maxlen, dst,src,proto,ttl,nbatr,tmout)
#define IN_CKSUM(nbuf,proto,off,len)	in4_cksum(nbuf,proto,off,len)
#define IN_IS_DSTADDR_ACCEPT(myaddr,dstaddr)			\
					in4_is_dstaddr_accept(myaddr,dstaddr)
#define IN_IFAWITHIFP(ifp,dst)		in4_ifawithifp(ifp,dst)
#define T_IN_IFADDR			T_IN4_IFADDR
#define T_IN_RTENTRY			T_IN4_RTENTRY

#endif	/* of #ifdef SUPPORT_INET4 */

/*
 *  롼ƥɽ
 */

extern T_IN_RTENTRY routing_tbl[];

/*
 *  
 */

#ifndef T_NET_BUF_DEFINED
typedef struct t_net_buf T_NET_BUF;
#define T_NET_BUF_DEFINED
#endif

#ifndef T_IFNET_DEFINED
typedef struct t_ifnet T_IFNET;
#define T_IFNET_DEFINED
#endif

/*
 *  ؿ
 */

extern void ip_input (T_NET_BUF *data);
extern ER in4_set_header (T_NET_BUF *nbuf, UINT len,
                          T_IN4_ADDR *dstaddr, T_IN4_ADDR *srcaddr, UB proto, UB ttl);
extern ER in4_get_datagram (T_NET_BUF **nbuf, UINT len, UINT maxlen,
                            T_IN4_ADDR *dstaddr, T_IN4_ADDR *srcaddr,
                            UB proto, UB ttl, ATR nbatr, TMO tmout);
extern UH in4_cksum (T_NET_BUF *nbuf, UB proto, UINT off, UINT len);
extern T_IN4_ADDR in4_rtalloc (T_IN4_ADDR dst);
extern void in4_rtredirect (T_IN4_ADDR gateway, T_IN4_ADDR target, UB flags, UW tmo);
extern void in4_init (void);
extern T_IN4_IFADDR *in4_ifawithifp (T_IFNET *ifp, T_IN4_ADDR *dst);
extern T_IN_RTENTRY *in_rtnewentry (UB flags, UW tmo);
extern void in_rttimer (void);
extern void in_rtinit (void);

/*
 *  in4_is_dstaddr_accept -- 襢ɥ쥹Ȥå롣
 *
 *    : dstaddr ϡ
 *          TINET-1.2 ͥåȥХȥ
 *          TINET-1.1 ޤǤϡۥȥХȥ
 */
extern BOOL in4_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_IN4_ADDR *dstaddr);

/*
 *  in_cksum -- å׻ؿIPv4ICMPv4 
 *
 *  : data  4 ƥåñ̤ǥѥǥ󥰤뤳ȡ
 *        data  2 ƥåñ̤˥饤󤵤Ƥʤ
 *        㳰ȯǽ롣
 *        len   4 ƥåñ̤˥饤󤵤Ƥ뤳ȡ
 */
extern UH in_cksum(VP data, UINT len /*ƥåñ*/);

/*
 *  in_cksum_sum -- åι׷׻ؿ
 *
 *  : data  4 ƥåñ̤ǥѥǥ󥰤뤳ȡ
 *        data  2 ƥåñ̤˥饤󤵤Ƥʤ
 *        㳰ȯǽ롣
 *        len   4 ƥåñ̤˥饤󤵤Ƥ뤳ȡ
 */
extern UW in_cksum_sum (VP data, UINT len /*ƥåñ*/);

/*
 *  in_cksum_carry -- åη夲׻ؿ
 *
 *  : data  4 ƥåñ̤ǥѥǥ󥰤뤳ȡ
 *        data  2 ƥåñ̤˥饤󤵤Ƥʤ
 *        㳰ȯǽ롣
 *        len   4 ƥåñ̤˥饤󤵤Ƥ뤳ȡ
 */
extern UW in_cksum_carry (UW sum);

#endif	/* of #ifndef _IN_VAR_H_ */
