/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2006 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_subr_cs.c,v 1.3 2006/02/07 10:10:51 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)tcp_subr.c	8.2 (Berkeley) 5/24/95
 * $FreeBSD: src/sys/netinet/tcp_subr.c,v 1.49.2.4 1999/08/29 16:29:55 peter Exp $
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet6/in6.h>
#include <netinet6/in6_var.h>
#include <netinet/in_var.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_var.h>
#include <netinet6/nd6.h>
#include <netinet/tcp.h>
#include <netinet/tcp_timer.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/tcp_seq.h>
#include <netinet/in_itron.h>

#ifdef SUPPORT_TCP

#ifdef TCP_CFG_SWBUF_CSAVE

#ifndef TCP_CFG_SWBUF_CSAVE_ONLY

/*
 *  TCP ̿üɥХåեξʥԡǽͭʾ
 *  ̿üɥХåեcep->sbufˤͤˤꡢ
 *  TCP ̿üɥХåեξʥԡǽѤ뤫
 *  Ѥʤڤؤ롣
 */

/*
 *  tcp_drop_swbuf -- ɥХåեꤵ줿ƥåʬˡ
 */

void
tcp_drop_swbuf (T_TCP_CCEP *cep, UINT len)
{
	if (IS_PTR_DEFINED(cep->sbuf))
		tcp_drop_swbuf_ncs(cep, len);
	else
		tcp_drop_swbuf_cs(cep, len);
	}

/*
 *  tcp_write_swbuf -- ɥХåե˥ǡ񤭹ˡ
 */

ER_UINT
tcp_write_swbuf (T_TCP_CCEP *cep, VP data, UINT len)
{
	if (IS_PTR_DEFINED(cep->sbuf))
		return tcp_write_swbuf_ncs(cep, data, len);
	else
		return tcp_write_swbuf_cs(cep, data, len);
	}

/*
 *  tcp_read_swbuf -- ɥХåեǡɤ߽Фˡ
 */

void
tcp_read_swbuf (T_TCP_CCEP *cep, T_NET_BUF *output, UINT len, UINT doff)
{
	if (IS_PTR_DEFINED(cep->sbuf))
		tcp_read_swbuf_ncs(cep, output, len, doff);
	}

/*
 *  tcp_wait_swbuf -- ɥХåեμɤΤԤġˡ
 */

ER
tcp_wait_swbuf (T_TCP_CCEP *cep, TMO tmout)
{
	if (IS_PTR_DEFINED(cep->sbuf))
		return tcp_wait_swbuf_ncs(cep, tmout);
	else
		return tcp_wait_swbuf_cs(cep, tmout);
	}

/*
 *  tcp_get_swbuf_addr -- ɥХåեζɥ쥹ˡ
 */

ER_UINT
tcp_get_swbuf_addr (T_TCP_CCEP *cep, VP *p_buf)
{
	if (IS_PTR_DEFINED(cep->sbuf))
		return tcp_get_swbuf_addr_ncs(cep, p_buf);
	else
		return tcp_get_swbuf_addr_cs(cep, p_buf);
	}

/*
 *  tcp_send_swbuf -- ɥХåեΥǡǽˤˡ
 */

void
tcp_send_swbuf (T_TCP_CCEP *cep, UINT len)
{
	if (IS_PTR_DEFINED(cep->sbuf))
		tcp_send_swbuf_ncs(cep, len);
	else
		tcp_send_swbuf_cs(cep, len);
	}

/*
 *  tcp_free_swbufq -- ɥХåե塼βؼˡ
 */

void
tcp_free_swbufq (T_TCP_CCEP *cep)
{
	if (!IS_PTR_DEFINED(cep->sbuf))
		tcp_free_swbufq_cs(cep);
	}

/*
 *  tcp_alloc_swbuf -- ɥХåեѤΥͥåȥХåեγƤؼˡ
 */

void
tcp_alloc_swbuf (T_TCP_CCEP *cep)
{
	if (!IS_PTR_DEFINED(cep->sbuf))
		tcp_alloc_swbuf_cs(cep);
	}

/*
 *  tcp_is_swbuf_full -- ɥХåեդåˡ
 */

BOOL
tcp_is_swbuf_full (T_TCP_CCEP *cep)
{
	if (IS_PTR_DEFINED(cep->sbuf))
		return tcp_is_swbuf_full_ncs(cep);
	else
		return tcp_is_swbuf_full_cs(cep);
	}

#endif	/* of #ifndef TCP_CFG_SWBUF_CSAVE_ONLY */

/*
 *  tcp_drop_swbuf_cs -- ɥХåեꤵ줿ƥåʬѡˡ
 */

void
tcp_drop_swbuf_cs (T_TCP_CCEP *cep, UINT len)
{

	/*ɥХåեꤵ줿ƥåʬ롣*/
	cep->swbuf_count -= (UH)len;

	/* ѤߤǡACKԤλϡACKλѹ롣*/
	if (len > 0 && (cep->flags & CEP_FLG_WBCS_MASK) == CEP_FLG_WBCS_SENT) {
		cep->flags = (cep->flags & ~CEP_FLG_WBCS_MASK) | CEP_FLG_WBCS_ACKED;
		sig_sem(SEM_TCP_POST_OUTPUT);
		}
	}

/*
 *  tcp_write_swbuf_cs -- ɥХåե˥ǡ񤭹ѡˡ
 */

ER_UINT
tcp_write_swbuf_cs (T_TCP_CCEP *cep, VP data, UINT len)
{
	ER_UINT	error;


	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	if ((error = net_buf_siz(cep->swbufq)) > 0) {


		/*
		 *  +-----------+--------+---------+---------+
		 *  | Ehter HDR | IP HDR | TCP HDR | TCP SDU |
		 *  +-----------+--------+---------+---------+
		 *        14        20        20        n
		 *   <---------------- error --------------->
		 *              ^
		 *              net_buf  4 ƥåȶ˥饤󤵤Ƥ롣
		 *
		 *  tcp_output  ip_output ǡå׻Ȥ
		 *  n  4 ƥåȶˤʤ褦 SDU θ 0 
		 *  ѥåǥ󥰤롣ʬθɥХåե
		 *   4 ƥåȶĴ롣
		 */
		error = (UINT)(((error - IF_IP_TCP_HDR_SIZE) >> 2 << 2) + IF_IP_TCP_HDR_SIZE);

		/* ޤlen ɥХåեζξܤˤ롣*/
		if (len > error - (cep->swbuf_count + IF_IP_TCP_HDR_SIZE))
			len = (UINT)(error - (cep->swbuf_count + IF_IP_TCP_HDR_SIZE));

		/* ɥˤꥵĴ롣*/
		if (len > cep->snd_wnd) 
			len = cep->snd_wnd;
		if (len > cep->snd_cwnd)
			len = cep->snd_cwnd;

		/* κȥ (maxseg) Ķʤ褦ˤ롣*/
		if (len > cep->maxseg) 
			len = cep->maxseg;

		/* ǡܤ*/
		memcpy(cep->sbuf_wptr, (VP)((UB*)data), (size_t)len);
		cep->sbuf_wptr   += len;
		cep->swbuf_count += len;
		error             = len;

		/* ͥåȥХåեĹ IP ǡĹꤹ롣*/
		cep->swbufq->len = (UH)(cep->swbuf_count + IF_IP_TCP_HDR_SIZE);
		SET_IP_SDU_SIZE(GET_IP_HDR(cep->swbufq), cep->swbuf_count + TCP_HDR_SIZE);

		/* ե饰ǽꤹ롣*/
		cep->flags = (UH)((cep->flags & ~CEP_FLG_WBCS_MASK) | CEP_FLG_WBCS_SEND_READY);
		}

	else {	/* ɥХåե */
		syslog(LOG_WARNING, "[TCP] illegal win buff for send, CEP: %d.", GET_TCP_CCEPID(cep));

		/* ɥХåե塼ΥͥåȥХåե롣*/
		tcp_free_swbufq_cs(cep);
		}

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

/*
 *  tcp_wait_swbuf_cs -- ɥХåեμɤΤԤġѡˡ
 */

ER
tcp_wait_swbuf_cs (T_TCP_CCEP *cep, TMO tmout)
{
	ER	error;
	INT	win;
	FLGPTN	flag;
	SYSTIM	before, after;


	/* ɥХåեƺѤߤǡнλ롣*/
	if ((cep->flags & CEP_FLG_WBCS_MASK) == CEP_FLG_WBCS_NBUF_READY &&
	    (cep->swbuf_count + IF_IP_TCP_HDR_SIZE) < net_buf_siz(cep->swbufq))
		return E_OK;

	/* ǤСλޤԵ롣*/
	while ((cep->flags & CEP_FLG_WBCS_MASK) != CEP_FLG_WBCS_FREE) {

		/* Ԥλ֤ tmout 鸺롣*/
		if (!(tmout == TMO_POL || tmout == TMO_FEVR))
			syscall(get_tim(&before));

		if ((error = twai_flg(cep->snd_flgid, CEP_EVT_SWBUF_READY,
		                      TWF_ORW, &flag, tmout)) != E_OK)
			return error;
		syscall(clr_flg(cep->snd_flgid, (FLGPTN)(~CEP_EVT_SWBUF_READY)));

		/* Ԥλ֤ tmout 鸺롣*/
		if (!(tmout == TMO_POL || tmout == TMO_FEVR)) {
			syscall(get_tim(&after));
			if (after - before > tmout)
				return E_TMOUT;
			tmout -= (TMO)(after - before);
			}

		/*
		 *  Ǥ뤫CEP  FSM ֤򸫤롣
		 *  ɥХåեޤԤĴ֤ˡǽˤʤäϡ
		 *  ͥǤ줿Ȥ̣Ƥ롣
		 */
		if (!TCP_FSM_CAN_SEND_MORE(cep->fsm_state))
			return E_CLS;
		}

	/* μɤĤƤϡޤԵ롣*/
	while (TRUE) {

		/*
		 *  snd_wnd:  μǽɥ
		 *  snd_cwnd: ԥɥ
		 *
		 *  win: ɤ餫ɥꤹ롣
		 */
		win = cep->snd_wnd < cep->snd_cwnd ? cep->snd_wnd : cep->snd_cwnd;
		if (win > 0)
			break;

		/* Ԥλ֤ tmout 鸺롣*/
		if (!(tmout == TMO_POL || tmout == TMO_FEVR))
			syscall(get_tim(&before));

		if ((error = twai_flg(cep->snd_flgid, CEP_EVT_SWBUF_READY,
		                      TWF_ORW, &flag, tmout)) != E_OK)
			return error;
		syscall(clr_flg(cep->snd_flgid, (FLGPTN)(~CEP_EVT_SWBUF_READY)));

		/* Ԥλ֤ tmout 鸺롣*/
		if (!(tmout == TMO_POL || tmout == TMO_FEVR)) {
			syscall(get_tim(&after));
			if (after - before > tmout)
				return E_TMOUT;
			tmout -= (TMO)(after - before);
			}

		/*
		 *  Ǥ뤫CEP  FSM ֤򸫤롣
		 *  ɥХåեޤԤĴ֤ˡǽˤʤäϡ
		 *  ͥǤ줿Ȥ̣Ƥ롣
		 */
		if (!TCP_FSM_CAN_SEND_MORE(cep->fsm_state))
			return E_CLS;
		}

	/* ͥåȥХåե롣*/
	if ((error = tcp_get_segment(&cep->swbufq, cep, 0,
	                             TCP_CFG_SWBUF_CSAVE_MIN_SIZE,
	                             TCP_CFG_SWBUF_CSAVE_MAX_SIZE - IF_IP_TCP_HDR_SIZE,
	                             NBA_SEARCH_DESCENT, tmout)) != E_OK)
		return error;

	/* ɥХåե롣*/
	tcp_init_swbuf(cep);

	return E_OK;
	}

/*
 *  tcp_get_swbuf_addr_cs -- ɥХåեζɥ쥹ѡˡ
 */

ER_UINT
tcp_get_swbuf_addr_cs (T_TCP_CCEP *cep, VP *p_buf)
{
	ER_UINT	error;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	if ((error = net_buf_siz(cep->swbufq)) > 0) {

		/*
		 *  +-----------+--------+---------+---------+
		 *  | Ehter HDR | IP HDR | TCP HDR | TCP SDU |
		 *  +-----------+--------+---------+---------+
		 *        14        20        20        n
		 *   <---------------- error --------------->
		 *              ^
		 *              net_buf  4 ƥåȶ˥饤󤵤Ƥ롣
		 *
		 *  tcp_output  ip_output ǡå׻Ȥ
		 *  n  4 ƥåȶˤʤ褦 SDU θ 0 
		 *  ѥåǥ󥰤롣ʬθɥХåե
		 *   4 ƥåȶĴ롣
		 */
		error = (UINT)(((error - IF_IP_TCP_HDR_SIZE) >> 2 << 2) - cep->swbuf_count);

		/* ɥˤꥵĴ롣*/
		if (error > cep->snd_wnd) 
			error = cep->snd_wnd;
		if (error > cep->snd_cwnd)
			error = cep->snd_cwnd;

		/* κȥ (maxseg) Ķʤ褦ˤ롣*/
		if (error > cep->maxseg) 
			error = cep->maxseg;

		/* ɥХåեζǡĹꤷ֤ͤ*/
		cep->get_buf_len = error;

		/* ɥХåեζɥ쥹Ƭꤹ롣*/
		*p_buf = cep->sbuf_wptr;
		}

	else {	/* ͥåȥХåե */

		/* ɥХåե塼ΥͥåȥХåե롣*/
		tcp_free_swbufq_cs(cep);
		}

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

/*
 *  tcp_send_swbuf_cs -- ɥХåեΥǡǽˤѡˡ
 */

void
tcp_send_swbuf_cs (T_TCP_CCEP *cep, UINT len)
{
	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	cep->sbuf_wptr  += len;
	cep->swbuf_count += len;

	/* ͥåȥХåեĹ IP ǡĹꤹ롣*/
	cep->swbufq->len = (UH)(cep->swbuf_count + IF_IP_TCP_HDR_SIZE);
	SET_IP_SDU_SIZE(GET_IP_HDR(cep->swbufq), len + TCP_HDR_SIZE);

	/* tcp_get_buf γĹꥻåȤ롣*/
	cep->get_buf_len = 0;

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	/* ե饰ǽꤷŪ롣*/
	cep->flags = (cep->flags & ~CEP_FLG_WBCS_MASK) | CEP_FLG_WBCS_SEND_READY
	                                               | CEP_FLG_FORCE
	                                               | CEP_FLG_FORCE_CLEAR
	                                               | CEP_FLG_POST_OUTPUT;
	}

/*
 *  tcp_free_swbufq_cs -- ɥХåե塼βؼѡˡ
 *
 *    :
 *      ɬפǤСδؿƤӽФˡ̿üå
 *      ä塢ɬפ롣
 */

void
tcp_free_swbufq_cs (T_TCP_CCEP *cep)
{
	/* ɥХåեζԤä*/
	cep->flags &= ~CEP_FLG_WBCS_NBUF_REQ;

	if ((cep->flags & CEP_FLG_WBCS_MASK) != CEP_FLG_WBCS_FREE) {
		/*
		 *  ɥХåե뤿ˡե饰 ACK λꤷ
		 *  TCP ϥư롣
		 */
		cep->flags = (cep->flags & ~CEP_FLG_WBCS_MASK) | CEP_FLG_WBCS_ACKED;
		sig_sem(SEM_TCP_POST_OUTPUT);
		}
	}

/*
 *  tcp_alloc_swbuf_cs -- ɥХåեѤΥͥåȥХåեγƤؼѡˡ
 */

void
tcp_alloc_swbuf_cs (T_TCP_CCEP *cep)
{
	cep->flags |= CEP_FLG_WBCS_NBUF_REQ;

	/*
	 *  ɥХåե̤ѤξΤߡ
	 *  ɥХåեѤΥͥåȥХåեγƤؼ롣
	 */
	if ((cep->flags & CEP_FLG_WBCS_MASK) == CEP_FLG_WBCS_FREE)
		sig_sem(SEM_TCP_POST_OUTPUT);
	}

/*
 *  tcp_is_swbuf_full_cs -- ɥХåեդåѡˡ
 */

BOOL
tcp_is_swbuf_full_cs (T_TCP_CCEP *cep)
{
	return (cep->flags & CEP_FLG_WBCS_MASK) != CEP_FLG_WBCS_NBUF_READY ||
	        cep->swbuf_count >= cep->swbufq->len - IF_IP_TCP_HDR_SIZE;
	}

/*
 *  tcp_init_swbuf -- ɥХåեѡˡ
 *
 *    : tcp_get_segment ǥͥåȥХåե
 *          ľ˸ƤӽФȡ
 */

void
tcp_init_swbuf (T_TCP_CCEP *cep)
{
	/* ɥХåեλ極ꥻåȤ롣*/
	cep->swbuf_count = 0;

	/* ɥХåեΥɥ쥹ꤹ롣*/
	cep->sbuf_wptr = cep->sbuf_rptr = GET_TCP_SDU(cep->swbufq, IF_IP_TCP_HDR_OFFSET);

	/* ե饰򡢥ͥåȥХåեƺѤߤꤹ롣*/
	cep->flags = (cep->flags & ~(CEP_FLG_WBCS_NBUF_REQ | CEP_FLG_WBCS_MASK))
	                         |   CEP_FLG_WBCS_NBUF_READY;
	}

/*
 *  tcp_push_res_nbuf -- ͥåȥХåեͽ󤹤ѡˡ
 */

T_NET_BUF *
tcp_push_res_nbuf (T_NET_BUF *nbuf)
{
	static int last_ix = 0;

 	int		ix, sel_ix;
	T_TCP_CCEP	*cep;

	if (++ last_ix == tmax_tcp_ccepid)
		last_ix = 0;
	sel_ix = ix = last_ix;
	do {
		cep = &tcp_ccep[ix];
		if ((cep->flags & CEP_FLG_WBCS_MASK) == CEP_FLG_WBCS_NBUF_PEND) {

			/* ͥåȥХåեͽ󤹤롣*/
			cep->swbufq = nbuf;
			nbuf = NULL;

			/* ե饰ͽꤹ롣*/
			cep->flags = (cep->flags & ~CEP_FLG_WBCS_MASK) | CEP_FLG_WBCS_NBUF_RSVD;
			sel_ix = ix;
			break;
			}
		if (++ ix == tmax_tcp_ccepid)
			ix = 0;
		} while (ix != last_ix);

	last_ix = sel_ix;

	return nbuf;
	}

/*
 *  tcp_pull_res_nbuf -- ͽ󤷤ƤͥåȥХåե֤ѡˡ
 */

T_NET_BUF *
tcp_pull_res_nbuf (ATR nbatr)
{
	T_NET_BUF	*nbuf;
	T_TCP_CCEP	*cep;

	cep = GET_TCP_CCEP(nbatr & NBA_ID_MASK);
	if ((cep->flags & CEP_FLG_WBCS_MASK) == CEP_FLG_WBCS_NBUF_RSVD) {

		/* ͽ󤷤ƤͥåȥХåե֤*/
		nbuf = cep->swbufq;
		cep->swbufq = NULL;

		/* TCP ϥư롣*/
		sig_sem(SEM_TCP_POST_OUTPUT);
		}
	else
		nbuf = NULL;

	return nbuf;
	}

#endif	/* of #ifdef TCP_CFG_SWBUF_CSAVE */

#ifdef TCP_CFG_RWBUF_CSAVE 

#ifndef TCP_CFG_RWBUF_CSAVE_ONLY

/*
 *  TCP ̿üμɥХåեξʥԡǽͭʾ
 *  ̿üμɥХåեcep->rbufˤͤˤꡢ
 *  TCP ̿ü˼ɥХåեξʥԡǽѤ뤫
 *  Ѥʤڤؤ롣
 */

/*
 *  tcp_drop_rwbuf -- ɥХåե塼κǽΥͥåȥХåե롣
 */

void
tcp_drop_rwbuf (T_TCP_CCEP *cep, UINT len)
{
	if (IS_PTR_DEFINED(cep->rbuf))
		tcp_drop_rwbuf_ncs(cep, len);
	else
		tcp_drop_rwbuf_cs(cep, len);
	}

/*
 *  tcp_read_rwbuf -- ɥХåեꤵ줿ƥåʬɤ߽Ф
 */

UINT
tcp_read_rwbuf (T_TCP_CCEP *cep, VP data, UINT len)
{
	if (IS_PTR_DEFINED(cep->rbuf))
		return tcp_read_rwbuf_ncs(cep, data, len);
	else
		return tcp_read_rwbuf_cs(cep, data, len);
	}

/*
 *  tcp_get_rwbuf_addr -- ɥХåեζɥ쥹롣
 */

UINT
tcp_get_rwbuf_addr (T_TCP_CCEP *cep, VP *p_buf)
{
	if (IS_PTR_DEFINED(cep->rbuf))
		return tcp_get_rwbuf_addr_ncs(cep, p_buf);
	else
		return tcp_get_rwbuf_addr_cs(cep, p_buf);
	}

/*
 *  tcp_free_rwbufq -- ɥХåե塼롣
 */

void
tcp_free_rwbufq (T_TCP_CCEP *cep)
{
	if (!IS_PTR_DEFINED(cep->rbuf))
		tcp_free_rwbufq_cs(cep);
	}

/*
 *  tcp_write_rwbuf -- ɥХåե˥ǡ񤭹ࡣ
 */

void
tcp_write_rwbuf (T_TCP_CCEP *cep, T_NET_BUF *input, UINT thoff)
{
	if (IS_PTR_DEFINED(cep->rbuf))
		tcp_write_rwbuf_ncs(cep, input, thoff);
	else
		tcp_write_rwbuf_cs(cep, input, thoff);
	}

#endif	/* of #ifndef TCP_CFG_RWBUF_CSAVE_ONLY */

/*
 *  TCP ̿üμɥХåեξʥԡǽͭ
 */

/*
 *  tcp_drop_rwbuf -- ɥХåե塼κǽΥͥåȥХåե롣
 */

void
tcp_drop_rwbuf_cs (T_TCP_CCEP *cep, UINT len)
{
	T_TCP_Q_HDR	*qhdr;

	if (cep->rwbufq != NULL) {

		qhdr = GET_TCP_Q_HDR(cep->rwbufq, GET_TCP_IP_Q_HDR(cep->rwbufq)->thoff);
		cep->rwbuf_count -= len;

		/* ͥåȥХåե˥ǡ̵ʤä롣*/
		if (len == qhdr->slen) {
			T_NET_BUF *next;

#ifdef TCP_CFG_RWBUF_CSAVE_MAX_QUEUES

			cep->rwbufq_entries --;

#endif	/* of #ifdef TCP_CFG_RWBUF_CSAVE_MAX_QUEUES */

			next = qhdr->next;
			syscall(rel_net_buf(cep->rwbufq));
			cep->rwbufq = next;
			}
		else {
			qhdr->slen -= len;
			qhdr->soff += len;
			}
		}
	}

/*
 *  tcp_read_rwbuf -- ɥХåեꤵ줿ƥåʬɤ߽Ф
 */

UINT
tcp_read_rwbuf_cs (T_TCP_CCEP *cep, VP data, UINT len)
{
	T_TCP_Q_HDR	*qhdr;
	UINT		blen, rlen = 0;
	UB		*buf = (UB*)data;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/*
	 *  ɥХåե塼˥ͥåȥХåե̵ʤ뤫
	 *  len  0 ˤʤޤ³롣
	 */
	while (cep->rwbufq != NULL && len > 0) {
		qhdr = GET_TCP_Q_HDR(cep->rwbufq, GET_TCP_IP_Q_HDR(cep->rwbufq)->thoff);

		/*
		 *  len ȼɥХåե塼ƬͥåȥХåե
		 *  ǡξܤǡˤ롣
		 */
		if (len > qhdr->slen)
			blen = qhdr->slen;
		else
			blen = len;

		memcpy(buf,
		       GET_TCP_SDU(cep->rwbufq, GET_TCP_IP_Q_HDR(cep->rwbufq)->thoff) + qhdr->soff,
		       (size_t)blen);

		/*
		 *  ɥХåե塼ΥͥåȥХåե
		 *  ǡ̵ʤä롣
		 */
		tcp_drop_rwbuf_cs(cep, blen);

		buf  += blen;
		rlen += blen;
		len  -= blen;
		}

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	return rlen;
	}

/*
 *  tcp_get_rwbuf_addr -- ɥХåեζɥ쥹롣
 */

UINT
tcp_get_rwbuf_addr_cs (T_TCP_CCEP *cep, VP *p_buf)
{
	T_TCP_Q_HDR	*qhdr;
	UINT		len;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	if (cep->rwbufq == NULL) {

		/* ɥХåեƳƤȤ*/
		*p_buf = NULL;
		len = 0;
		}
	else {

		/* ɥХåեΥǡΥɥ쥹Ƭꤹ롣*/
		qhdr = GET_TCP_Q_HDR(cep->rwbufq, GET_TCP_IP_Q_HDR(cep->rwbufq)->thoff);
		*p_buf = GET_TCP_SDU(cep->rwbufq, GET_TCP_IP_Q_HDR(cep->rwbufq)->thoff) + qhdr->soff;

		/* ɥХåեΥǡĹ׻롣*/
		len = qhdr->slen;
		}

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	/* ɥХåեΥǡĹꤷ֤ͤ*/
	cep->rcv_buf_len = len;
	return len;
	}

/*
 *  tcp_free_rwbufq -- ɥХåե塼롣
 *
 *    :
 *      ɬפǤСδؿƤӽФˡ̿üå
 *      ä塢ɬפ롣
 */

void
tcp_free_rwbufq_cs (T_TCP_CCEP *cep)
{
	T_NET_BUF *next;

	while (cep->rwbufq != NULL) {
		next = GET_TCP_Q_HDR(cep->rwbufq, GET_TCP_IP_Q_HDR(cep->rwbufq)->thoff)->next;

#ifdef TCP_CFG_RWBUF_CSAVE_MAX_QUEUES

		cep->rwbufq_entries --;

#endif	/* of #ifdef TCP_CFG_RWBUF_CSAVE_MAX_QUEUES */

		syscall(rel_net_buf(cep->rwbufq));
		cep->rwbufq = next;
		}

	/* ɥХåեλ極ꥻåȤ롣*/
	cep->rwbuf_count = 0;
	}

/*
 *  tcp_write_rwbuf -- ɥХåե˥ǡ񤭹ࡣ
 *
 *    :
 *	 input ϡT_TCP_Q_HDR ˤ󥯤졢
 *	¤ؤλƤʤФʤʤޤ
 *	ɲäǡϡɥХåե˼ޤ뤳ȡ
 */

void
tcp_write_rwbuf_cs (T_TCP_CCEP *cep, T_NET_BUF *input, UINT thoff)
{
	T_TCP_Q_HDR	*qhdr;
	T_NET_BUF	**nextp;
	UINT		inlen, last;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	qhdr  = (T_TCP_Q_HDR*)GET_TCP_HDR(input, thoff);

	inlen = qhdr->slen;

#ifdef TCP_CFG_RWBUF_CSAVE_MAX_QUEUES

	if (cep->rwbufq_entries >= TCP_CFG_RWBUF_CSAVE_MAX_QUEUES &&
	    inlen > 0 && (qhdr->flags & TCP_FLG_FIN) == 0) {

		/*
		 *  TCP ̿üμɥХåեξʥԡǽΡ
		 *  ɥХåե塼κ票ȥĶȤϡ
		 *  Ȥ˴롣
		 *  SDU Ĺ 0 ΥȤ FIN Ȥ˴ʤ
		 *  ʤ˼Ȥ˴뤿ᡢä롣
		 */
		syscall(rel_net_buf(input));

		/* ̿üΥå롣*/
		syscall(sig_sem(cep->semid_lock));
		return;
		}

	cep->rwbufq_entries ++;

#endif	/* of #ifdef TCP_CFG_RWBUF_CSAVE_MAX_QUEUES */

	qhdr  = (T_TCP_Q_HDR*)GET_TCP_HDR(input, thoff);

	/* Ѥߥֹ򹹿롣*/
	cep->rcv_nxt += inlen;

	last  = cep->rwbuf_count;

	/* ͥåȥХåեɥХåե塼κǸϢ뤹롣*/
	qhdr->next = NULL;
	nextp = &cep->rwbufq;
	while (*nextp)
		nextp = &GET_TCP_Q_HDR(*nextp, GET_TCP_IP_Q_HDR(*nextp)->thoff)->next;
	*nextp = input;

	/*
	 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
	 *  ϡץꥱˡ꤫餳ʾǡ
	 *  ʤȤΤ餻뤿Ǥ롣
	 */
	if (inlen > 0) {
		cep->rwbuf_count += inlen;
		NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_DATA_SEGS],   1);
		NET_COUNT_TCP(net_count_tcp[NC_TCP_RECV_DATA_OCTETS], inlen);
		}

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

#ifdef TCP_CFG_NON_BLOCKING

	if (cep->rcv_nblk_tfn == TFN_TCP_RCV_BUF) {	/* Υ֥å󥰥 */

		INT	len;

		qhdr = GET_TCP_Q_HDR(cep->rwbufq, GET_TCP_IP_Q_HDR(cep->rwbufq)->thoff);
		len = qhdr->slen;

		/*
		 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
		 *  ϡץꥱˡ꤫餳ʾǡ
		 *  ʤȤΤ餻뤿Ǥ롣
		 */
		if (len > 0 || inlen == 0) {

			/* tcp_rcv_buf γĹꤹ롣*/
			cep->rcv_buf_len = len;

			/* ɥХåեΥɥ쥹֤*/
			*cep->rcv_p_buf = GET_TCP_SDU(cep->rwbufq,
			                  GET_TCP_IP_Q_HDR(cep->rwbufq)->thoff) + qhdr->soff;

			if (IS_PTR_DEFINED(cep->callback))
				(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)len);
			else
				syslog(LOG_WARNING, "[TCP] no call back, CEP: %d.", GET_TCP_CCEPID(cep));

			if (len == 0) {

				/*
				 *  ̿üåơ
				 *  ɥХåե塼ΥͥåȥХåե롣
				 */
				syscall(wai_sem(cep->semid_lock));
				tcp_free_rwbufq_cs(cep);
				syscall(sig_sem(cep->semid_lock));
				}
			}

		/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
		cep->rcv_tskid = TA_NULL;
		cep->rcv_tfn   = cep->rcv_nblk_tfn = TFN_TCP_UNDEF;
		}

	else if (cep->rcv_nblk_tfn == TFN_TCP_RCV_DAT) {	/* Υ֥å󥰥 */
		INT	len;

		/* ɥХåեǡФ*/
		if ((len = tcp_read_rwbuf_cs(cep, cep->rcv_data, (UINT)cep->rcv_len)) > 0) {
			/* ˥ɥѤäȤΤ餻뤿ϤݥȤ롣*/
			cep->flags |= CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);
			}

		/*
		 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
		 *  ϡץꥱˡ꤫餳ʾǡ
		 *  ʤȤΤ餻뤿Ǥ롣
		 */
		if (len > 0 || inlen == 0) {

			if (IS_PTR_DEFINED(cep->callback))
				(*cep->callback)(GET_TCP_CCEPID(cep), cep->rcv_nblk_tfn, (VP)len);
			else
				syslog(LOG_WARNING, "[TCP] no call back, CEP: %d.", GET_TCP_CCEPID(cep));
			}

		/* Ƥ륿 ID  API ǽɤ򥯥ꥢ롣*/
		cep->rcv_tskid = TA_NULL;
		cep->rcv_tfn   = cep->rcv_nblk_tfn = TFN_TCP_UNDEF;
		}
	else {

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

		if (inlen == 0 && cep->rwbuf_count == 0) {
			/*
			 *  ɥХåեΥǡ 0 ǡ
			 *  ꤫ FIN ե饰դȤȤϡ
			 *  ̿üåơ
			 *  ɥХåե塼ΥͥåȥХåե롣
			 */
			syscall(wai_sem(cep->semid_lock));
			tcp_free_rwbufq_cs(cep);
			syscall(sig_sem(cep->semid_lock));
			}

		/*
		 *  ɥХåե˥ǡ뤫 inlen == 0 λϥ򵯾롣
		 *  FIN ե饰դȤ inlen == 0 ˤʤ뤳Ȥ⤢롣
		 *  ϡץꥱˡ꤫餳ʾǡ
		 *  ʤȤΤ餻뤿Ǥ롣
		 */
		if ((last == 0 && cep->rwbuf_count > 0) || inlen == 0)
			syscall(set_flg(cep->rcv_flgid, CEP_EVT_RWBUF_READY));

#ifdef TCP_CFG_NON_BLOCKING

		}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	}

#endif	/* of #ifdef TCP_CFG_RWBUF_CSAVE */

#endif	/* of #ifdef SUPPORT_TCP */
